\begin{frame}
  \frametitle{Parallel implementations}%
  \begin{block}{Coarse grained parallelization\footfullcite{Zhou2011}}
    \begin{minipage}[t]{\textwidth}
      \mbox{}%
      \begin{minipage}{.59\textwidth}
        \begin{itemize}
          \item Execute many independent runs in parallel.
          \item The SSA is ``Single Instruction -- Multiple Data (SIMD)''
          \item[$\Rightarrow$] Well suited for threaded computing
          \item Best performance gain observed on GPGPUs.
          %\item[$\Leftrightarrow$] Shared memory on GPGPUs is limited $\rightarrow$ $N+M<63$.
        \end{itemize}
      \end{minipage}
      \begin{minipage}{.4\textwidth}%
        \begin{center}
          \includegraphics[width=1\textwidth,angle=0,clip]{Screenshot_2019-10-16_15-10-26}
        \end{center}
      \end{minipage}
    \end{minipage}
  \end{block}
\end{frame}
%
\begin{frame}
  \begin{block}{Combination of coarse \& fine grained parallelization\footfullcite{Komarov2012}}%
    \begin{minipage}[t]{\textwidth}%
      \begin{minipage}{.55\textwidth}%
        \begin{itemize}%
          \item Each realization occupies a group of hardware--coupled threads (``warp)''
          \item Parallelize most compute intensive part of SSA over blocks within warp
          \includegraphics[height=4.0\baselineskip,angle=0,clip]{cuda_blocks-warps-threads_from_nvidia}
          \item Reaction rates $c_\nu$ must be over time.
          \item[$\Leftrightarrow$] Genetic change
        \end{itemize}%
      \end{minipage}%
      \hfill%
      \begin{minipage}{.38\textwidth}%
        \begin{center}%
          \includegraphics[height=.93\textheight,angle=0,clip]{gpu-ssa.png}%
        \end{center}%
      \end{minipage}%
    \end{minipage}%
  \end{block}
\end{frame}

